#ifndef _ScaleDialog_H_
#   define _ScaleDialog_H_

#include <qdialog.h>

struct ScaleDialogPrivate;

class ScaleDialog : public QDialog
{
   Q_OBJECT

   public:
      ScaleDialog(
         int widthPixels,
         int heightPixels,
         double dpi = 72.0,
         QWidget *parent = 0
      );

      ~ScaleDialog();

      int getPixelWidth();
      int getPixelHeight();

      static int main(int argc, char **argv);

   protected slots:
      void done(int value);

   private:
      ScaleDialog(const ScaleDialog &);
      ScaleDialog &operator=(const ScaleDialog &);

      ScaleDialogPrivate *mPrivate;

   private slots:
      void slotPixelWidthChanged(double value);
      void slotPixelHeightChanged(double value);

      void slotPixelWidthUnitsChanged(int index);
      void slotPixelHeightUnitsChanged(int index);

      void slotPrintWidthChanged(double value);
      void slotPrintHeightChanged(double value);
      void slotPrintResolutionChanged(double value);

      void slotPrintWidthUnitsChanged(int index);
      void slotPrintHeightUnitsChanged(int index);
      void slotPrintResolutionUnitsChanged(int index);
};

#endif
