#ifndef _ATTRIBUTE_NODE_H_
#   define _ATTRIBUTE_NODE_H_

#include <string>

#include "Node.h"

class Component;

class AttributeNode : public Node
{
   public:

      typedef enum {
         _UNKNOWN,
         _LEFT,
         _RIGHT,
         _TOP,
         _BOTTOM,
         _XCENTER,
         _YCENTER,
         _WIDTH,
         _HEIGHT,
         _DEFAULT_WIDTH,
         _DEFAULT_HEIGHT

      } Attribute;

      AttributeNode(
         const char *name,
         Attribute theAttribute
      );

      ~AttributeNode();

      Attribute get() const;

      double evaluate() const;

      ostream &print(ostream &out) const;

      Node *copy() const;

      void accept(Visitor &) const;

      char *getQualifiedName() const;

      void setComponent(Component *);

      static AttributeNode *createFromQualifiedIdentifier(
         char *identifier, std::string &errMsg
      );

   private:
      AttributeNode(const AttributeNode &);
      AttributeNode &operator=(const AttributeNode &);
      const char *attributeAsString() const;

      char *mQualifiedName;
      Attribute mAttribute;
      Component *mComponent;
};

#endif
