// QALE headers

#include "ConstantNode.h"
#include "Visitor.h"

/*****************************************************************************
 * Definition of class: ConstantNode
 *****************************************************************************/

ConstantNode::ConstantNode(double theValue)
   : mValue(theValue)
{
   // Nothing to do
}

ConstantNode::~ConstantNode()
{
   // Nothing to do
}

double ConstantNode::evaluate() const
{
   return(mValue);
}

ostream &ConstantNode::print(ostream &out) const
{
   return(
      out << mValue
   );
}

Node *ConstantNode::copy() const
{
   return(
      new ConstantNode(mValue)
   );
}

void ConstantNode::accept(Visitor &v) const
{
   v.visited((ConstantNode *)this);
}
