// QALE headers

#include "CountingMessageReceiver.h"

/*****************************************************************************
 * Definition of class: CountingMessageReceiver
 *****************************************************************************/

CountingMessageReceiver::CountingMessageReceiver(
   MessageReceiver &receiver
)  :
   mReceiver(receiver),
   mCount(0)
{
   // Nothing to do
}

CountingMessageReceiver::~CountingMessageReceiver()
{
   // Nothing to do
}

void CountingMessageReceiver::accept(const char *message)
{
   mCount++;

   mReceiver.accept(message);
}

int CountingMessageReceiver::getCount() const
{
   return(mCount);
}
