#ifndef _QCOMPONENT_H_
#   define _QCOMPONENT_H_

#include "Component.h"

class QWidget;

// Setting this environment variable to any value causes QComponent to
// print out a message to stdout any time the QComponent is moved or
// resized

#define QALE_VERBOSE "QALE_VERBOSE"

class QComponent : public Component
{
   public:
      QComponent(int index, QWidget *q);
      ~QComponent();

      double getLeft()   const;
      double getRight()  const;
      double getTop()    const;
      double getBottom() const;
      double getX()      const;
      double getY()      const;
      double getWidth()  const;
      double getHeight() const;

      virtual void setLocation(double x, double y);
      virtual void setSize(double width, double height);

      int hasProperty(const char *propertyName) const;
      double getProperty(const char *propertyName) const;

   protected:
      virtual void getLocation(double *xPtr, double *yPtr) const;
      virtual void getSize(double *widthPtr, double *heightPtr) const;
      QWidget *getWidget() const;

   private:
      QWidget *mWidget;
      double mWidth;
      double mHeight;
      double mXLocation;
      double mYLocation;

      // By setting the environment variable 'QALE_VERBOSE' you
      // can instruct all QComponent objects to write a message to stdout
      // whenever they are resized or moved

      static int mVerboseOutput;
};

#endif
